ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.11 by root, Wed Dec 8 22:27:35 2010 UTC vs.
Revision 1.43 by root, Tue May 10 17:40:17 2011 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 17
19ARCH="$(uname -m)" 18ARCH="$(uname -m)"
20 19
21case "$ARCH" in 20case "$ARCH" in
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 37
38# some configuration options for modules 38# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
41export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
42 44
43# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
44# required by mkbundle 46# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 48
47# which extra modules you might want to install 49# which extra modules you might want to install
48EXTRA_MODULES="" 50EXTRA_MODULES=""
49 51
50# overridable functions 52# overridable functions
51preconfigure() { : ; } 53preconfigure() { : ; }
54patchconfig() { : ; }
52postconfigure() { : ; } 55postconfigure() { : ; }
53postbuild() { : ; } 56postbuild() { : ; }
54postinstall() { : ; } 57postinstall() { : ; }
55 58
56# now source user config, if any 59# now source user config, if any
60if [ "$STATICPERLRC" ]; then
61 . "$STATICPERLRC"
62else
57[ -r /etc/staticperlrc ] && . /etc/staticperlrc 63 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
58[ -r ~/.staticperlrc ] && . ~/.staticperlrc 64 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
59[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 65 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
66fi
60 67
61############################################################################# 68#############################################################################
62# support 69# support
70
71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
72
73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
63 80
64# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
65VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
66$VERSION=0.9 83$VERSION="1.3"
67 84
68BZ2=bz2 85BZ2=bz2
69BZIP2=bzip2 86BZIP2=bzip2
70 87
71fatal() { 88fatal() {
104############################################################################# 121#############################################################################
105# clean 122# clean
106 123
107distclean() { 124distclean() {
108 verblock <<EOF 125 verblock <<EOF
109deleting everything installed by this script 126 deleting everything installed by this script (rm -rf $STATICPERL)
110EOF 127EOF
111 128
112 rm -rf "$STATICPERL" 129 rm -rf "$STATICPERL"
113} 130}
114 131
115############################################################################# 132#############################################################################
116# download/configure/compile/install perl 133# download/configure/compile/install perl
117 134
118clean() { 135clean() {
119 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 136 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
137}
138
139realclean() {
140 rm -f "$PERL_PREFIX/staticstamp.postinstall"
141 rm -f "$PERL_PREFIX/staticstamp.install"
142 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
120} 143}
121 144
122fetch() { 145fetch() {
123 rcd "$STATICPERL" 146 rcd "$STATICPERL"
124 147
133 verblock <<EOF 156 verblock <<EOF
134downloading perl 157downloading perl
135to manually download perl yourself, place 158to manually download perl yourself, place
136perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
137trying $URL 160trying $URL
161
162either curl or wget is required for automatic download.
163curl is tried first, then wget.
138EOF 164EOF
139 165
140 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 166 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
167 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
141 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 168 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
142 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
143 || fatal "$URL: unable to download" 169 || fatal "$URL: unable to download"
170 rm -f perl-$PERL_VERSION.tar.$BZ2
144 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 171 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
145 fi 172 fi
146 173
147 verblock <<EOF 174 verblock <<EOF
148unpacking perl 175unpacking perl
149EOF 176EOF
150 177
151 mkdir -p unpack 178 mkdir -p unpack
179 rm -rf unpack/perl-$PERL_VERSION
152 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xC unpack \ 180 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
153 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 181 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
154 chmod -R u+w unpack/perl-$PERL_VERSION 182 chmod -R u+w unpack/perl-$PERL_VERSION
155 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 183 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
156 rmdir -p unpack 184 rmdir -p unpack
157 fi 185 fi
158} 186}
159 187
160# similar to GNU-sed -i or perl -pi 188# similar to GNU-sed -i or perl -pi
161sedreplace() { 189sedreplace() {
162 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 190 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
191 rm -f "$2"
163 mv "$2~" "$2" 192 mv "$2~" "$2"
193}
194
195configure_failure() {
196 cat <<EOF
197
198
199***
200*** Configure failed - see above for the exact error message(s).
201***
202*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
203*** flags are not supported by your compiler. Less often, this is because
204*** PERL_LIBS either contains a library not available on your system (such as
205*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
206***
207*** You can provide your own flags by creating a ~/.staticperlrc file with
208*** variable assignments. For example (these are the actual values used):
209***
210
211PERL_CC="$PERL_CC"
212PERL_CCFLAGS="$PERL_CCFLAGS"
213PERL_OPTIMIZE="$PERL_OPTIMIZE"
214PERL_LDFLAGS="$PERL_LDFLAGS"
215PERL_LIBS="$PERL_LIBS"
216
217EOF
218 exit 1
164} 219}
165 220
166configure() { 221configure() {
167 fetch 222 fetch
168 223
174configuring $STATICPERL/src/perl-$PERL_VERSION 229configuring $STATICPERL/src/perl-$PERL_VERSION
175EOF 230EOF
176 231
177 rm -f "$PERL_PREFIX/staticstamp.install" 232 rm -f "$PERL_PREFIX/staticstamp.install"
178 233
179 make distclean >/dev/null 2>&1 234 "$MAKE" distclean >/dev/null 2>&1
180 235
236 sedreplace '/^#define SITELIB/d' config_h.SH
237
181 # I hate them 238 # I hate them for this
182 grep -q -- -fstack-protector Configure && \ 239 grep -q -- -fstack-protector Configure && \
183 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 240 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
184 241
185 preconfigure 242 # what did that bloke think
243 grep -q -- usedl=.define hints/darwin.sh && \
244 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
245
246 preconfigure || fatal "preconfigure hook failed"
186 247
187# trace configure \ 248# trace configure \
188 sh Configure -Duselargefiles \ 249 sh Configure -Duselargefiles \
189 -Uuse64bitint \ 250 -Uuse64bitint \
190 -Dusemymalloc=n \ 251 -Dusemymalloc=n \
191 -Uusedl \ 252 -Uusedl \
192 -Uusethreads \ 253 -Uusethreads \
193 -Uuseithreads \ 254 -Uuseithreads \
194 -Uusemultiplicity \ 255 -Uusemultiplicity \
195 -Duseperlio \
196 -Uusesfio \ 256 -Uusesfio \
197 -Uuseshrplib \ 257 -Uuseshrplib \
258 -Uinstallusrbinperl \
198 -Dcppflags="$PERL_CPPFLAGS" \ 259 -A ccflags=" $PERL_CCFLAGS" \
199 -Dccflags="-g2 -fno-strict-aliasing" \ 260 -Dcc="$PERL_CC" \
200 -Doptimize="$PERL_OPTIMIZE" \ 261 -Doptimize="$PERL_OPTIMIZE" \
201 -Dldflags="$PERL_LDFLAGS" \ 262 -Dldflags="$PERL_LDFLAGS" \
202 -Dlibs="$PERL_LIBS" \ 263 -Dlibs="$PERL_LIBS" \
203 -Dprefix="$PERL_PREFIX" \ 264 -Dprefix="$PERL_PREFIX" \
204 -Dbin="$PERL_PREFIX/bin" \ 265 -Dbin="$PERL_PREFIX/bin" \
205 -Dprivlib="$PERL_PREFIX/lib" \ 266 -Dprivlib="$PERL_PREFIX/lib" \
206 -Darchlib="$PERL_PREFIX/lib" \ 267 -Darchlib="$PERL_PREFIX/lib" \
207 -Uusevendorprefix \ 268 -Uusevendorprefix \
208 -Dsitelib="$PERL_PREFIX/lib" \ 269 -Dsitelib="$PERL_PREFIX/lib" \
209 -Dsitearch="$PERL_PREFIX/lib" \ 270 -Dsitearch="$PERL_PREFIX/lib" \
210 -Usitelibexp \
211 -Uman1dir \ 271 -Uman1dir \
212 -Uman3dir \ 272 -Uman3dir \
213 -Usiteman1dir \ 273 -Usiteman1dir \
214 -Usiteman3dir \ 274 -Usiteman3dir \
215 -Dpager=/usr/bin/less \ 275 -Dpager=/usr/bin/less \
216 -Demail="$EMAIL" \ 276 -Demail="$EMAIL" \
217 -Dcf_email="$EMAIL" \ 277 -Dcf_email="$EMAIL" \
218 -Dcf_by="$EMAIL" \ 278 -Dcf_by="$EMAIL" \
219 $PERL_CONFIGURE \ 279 $PERL_CONFIGURE \
280 -Duseperlio \
220 -dE || fatal "Configure failed" 281 -dE || configure_failure
221 282
222 sedreplace ' 283 sedreplace '
223 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 284 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
224 s/ *-fno-stack-protector */ /g 285 s/ *-fno-stack-protector */ /g
225 ' config.sh 286 ' config.sh
226 287
288 patchconfig || fatal "patchconfig hook failed"
289
227 sh Configure -S || fatal "Configure -S failed" 290 sh Configure -S || fatal "Configure -S failed"
228 291
229 postconfigure || fatal "postconfigure hook failed" 292 postconfigure || fatal "postconfigure hook failed"
230 293
231 touch staticstamp.configure 294 touch staticstamp.configure
295}
296
297write_shellscript() {
298 {
299 echo "#!/bin/sh"
300 echo "STATICPERL=\"$STATICPERL\""
301 echo "PERL_PREFIX=\"$PERL_PREFIX\""
302 echo "MAKE=\"$MAKE\""
303 cat
304 } >"$PERL_PREFIX/bin/$1"
305 chmod 755 "$PERL_PREFIX/bin/$1"
232} 306}
233 307
234build() { 308build() {
235 configure 309 configure
236 310
240building $STATICPERL/src/perl-$PERL_VERSION 314building $STATICPERL/src/perl-$PERL_VERSION
241EOF 315EOF
242 316
243 rm -f "$PERL_PREFIX/staticstamp.install" 317 rm -f "$PERL_PREFIX/staticstamp.install"
244 318
245 make || fatal "make: error while building perl" 319 "$MAKE" || fatal "make: error while building perl"
246 320
247 postbuild || fatal "postbuild hook failed" 321 postbuild || fatal "postbuild hook failed"
248} 322}
249 323
250install() { 324install() {
254 verblock <<EOF 328 verblock <<EOF
255installing $STATICPERL/src/perl-$PERL_VERSION 329installing $STATICPERL/src/perl-$PERL_VERSION
256to $PERL_PREFIX 330to $PERL_PREFIX
257EOF 331EOF
258 332
259 rm -rf "$PERL_PREFIX" 333 ln -sf "perl/bin/" "$STATICPERL/bin"
260 334 ln -sf "perl/lib/" "$STATICPERL/lib"
335
336 mkdir "$STATICPERL/patched"
337
338 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
339 rm -rf "$PERL_PREFIX" # by this rm -rf
340
261 make install || fatal "make install: error while installing" 341 "$MAKE" install || fatal "make install: error while installing"
262 342
263 rcd "$PERL_PREFIX" 343 rcd "$PERL_PREFIX"
264 344
265 # create a "make install" replacement for CPAN 345 # create a "make install" replacement for CPAN
266 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 346 write_shellscript SP-make-install-make <<'EOF'
267make || exit 347#CAT make-install-make.sh
268
269if find blib/arch/auto -type f | grep -q -v .exists; then
270 echo Probably an XS module, rebuilding perl
271 if make perl; then
272 mv perl "$PERL_PREFIX"/bin/perl
273 make -f Makefile.aperl map_clean
274 else
275 make -f Makefile.aperl map_clean
276 exit 1
277 fi
278fi
279
280make install UNINST=1
281EOF 348EOF
282 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
283 349
350 # create a "patch modules" helper
351 write_shellscript SP-patch-postinstall <<'EOF'
352#CAT patch-postinstall.sh
353EOF
354
355 "$PERL_PREFIX/bin/SP-patch-postinstall"
356
284 # trick CPAN into avoiding ~/.cpan completely 357 # help to trick CPAN into avoiding ~/.cpan completely
285 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 358 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
286 359
360 # we call cpan with -MCPAN::MyConfig in this script, which
361 # is strictly unnecssary as we have to patch CPAN anyway,
362 # so consider it "for good measure".
287 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 363 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
288 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 364 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
289 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 365 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
290 CPAN::Shell->o (conf => q<init>); 366 CPAN::Shell->o (conf => q<init>);
291 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 367 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
292 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 368 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
293 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 369 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
294 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 370 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
295 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 371 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
296 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 372 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
297 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 373 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
298 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 374 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
375 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
299 CPAN::Shell->o (conf => q<commit>); 376 CPAN::Shell->o (conf => q<commit>);
300 ' || fatal "error while initialising CPAN" 377 ' || fatal "error while initialising CPAN"
301 378
302 touch "$PERL_PREFIX/staticstamp.install" 379 touch "$PERL_PREFIX/staticstamp.install"
303 fi 380 fi
323installing modules from CPAN 400installing modules from CPAN
324$@ 401$@
325EOF 402EOF
326 403
327 for mod in "$@"; do 404 for mod in "$@"; do
328 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 405 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
329 || fatal "$mod: unable to install from CPAN" 406 || fatal "$mod: unable to install from CPAN"
330 done 407 done
331 rm -rf "$STATICPERL/build" 408 rm -rf "$STATICPERL/build"
332} 409}
333 410
345 for mod in "$@"; do 422 for mod in "$@"; do
346 echo 423 echo
347 echo $mod 424 echo $mod
348 ( 425 (
349 rcd $mod 426 rcd $mod
350 make -f Makefile.aperl map_clean >/dev/null 2>&1 427 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
351 make distclean >/dev/null 2>&1 428 "$MAKE" distclean >/dev/null 2>&1
352 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 429 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
353 make || fatal "$mod: error building module" 430 "$MAKE" || fatal "$mod: error building module"
354 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 431 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
355 make distclean >/dev/null 2>&1 432 "$MAKE" distclean >/dev/null 2>&1
356 exit 0 433 exit 0
357 ) || exit $? 434 ) || exit $?
358 done 435 done
359} 436}
360 437
361############################################################################# 438#############################################################################
362# main 439# main
363 440
364podusage() { 441podusage() {
365 echo 442 echo
443
366 if [ -e "$PERL_PREFIX/bin/perl" ]; then 444 if [ -e "$PERL_PREFIX/bin/perl" ]; then
367 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 445 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
368 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 446 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
369 2>/dev/null && exit 447 2>/dev/null && exit
370 fi 448 fi
449
371 # try whatever perl we can find 450 # try whatever perl we can find
372 perl -MPod::Usage -e \ 451 perl -MPod::Usage -e \
373 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 452 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
374 2>/dev/null && exit 453 2>/dev/null && exit
375 454
376 fatal "displaying documentation requires a working perl - try '$0 install' first" 455 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
377} 456}
378 457
379usage() { 458usage() {
380 podusage 0 459 podusage 0
381} 460}
389#CAT mkbundle 468#CAT mkbundle
390MKBUNDLE 469MKBUNDLE
391} 470}
392 471
393bundle() { 472bundle() {
473 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
394 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 474 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
395 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 475 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
476 CACHE="$STATICPERL/cache"
477 mkdir -p "$CACHE"
396 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 478 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
397} 479}
398 480
399if [ $# -gt 0 ]; then 481if [ $# -gt 0 ]; then
400 while [ $# -gt 0 ]; do 482 while [ $# -gt 0 ]; do
401 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 483 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
402 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 484 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
403 485
404 command="${1#--}"; shift 486 command="${1#--}"; shift
405 case "$command" in 487 case "$command" in
488 version )
489 echo "staticperl version $VERSION"
490 ;;
406 fetch | configure | build | install | clean | distclean) 491 fetch | configure | build | install | clean | realclean | distclean)
407 verblock <<EOF
408$command
409EOF
410 ( "$command" ) 492 ( "$command" ) || exit
411 ;; 493 ;;
412 instsrc ) 494 instsrc )
413 ( instsrc "$@" ) 495 ( instsrc "$@" ) || exit
414 exit 496 exit
415 ;; 497 ;;
416 instcpan ) 498 instcpan )
417 ( instcpan "$@" ) 499 ( instcpan "$@" ) || exit
500 exit
501 ;;
502 perl )
503 ( install ) || exit
504 exec "$PERL_PREFIX/bin/perl" "$@"
418 exit 505 exit
419 ;; 506 ;;
420 cpan ) 507 cpan )
421 ( install ) 508 ( install ) || exit
422 "$PERL_PREFIX/bin/cpan" "$@" 509 exec "$PERL_PREFIX/bin/cpan" "$@"
423 exit 510 exit
424 ;; 511 ;;
425 mkbundle ) 512 mkbundle )
426 ( install ) 513 ( install ) || exit
427 bundle "$@" 514 bundle "$@"
428 exit 515 exit
429 ;; 516 ;;
430 mkperl ) 517 mkperl )
431 ( install ) 518 ( install ) || exit
432 bundle --perl "$@" 519 bundle --perl "$@"
433 exit 520 exit
434 ;; 521 ;;
435 mkapp ) 522 mkapp )
436 ( install ) 523 ( install ) || exit
437 bundle --app "$@" 524 bundle --app "$@"
438 exit 525 exit
439 ;; 526 ;;
440 help ) 527 help )
441 podusage 2 528 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines